/* exercice 1, Langage L1 : 0(C)>1(C)
   base : 0 est un mot de L1
   cas général : si le mot commence par 0 alors le reste contient
   un nombre de 0 supérieur ou égal au nombre de 1 ;
   si le mot commence par 1 alors le reste se décompose en deux
   mots de L1.
*/
s1 --> [0];    [0], egal;    [0], s1.
s1 --> [1], s1, s1.
egal --> [];    [0], egal, [1], egal;    [1], egal, [0], egal.



/**
 *  L2 = { c ∈ {0, 1}∗ ; 0(c) = 2 × 1(c) } ;
 *  s2 -> Epsilon 0s20s21s2 ou 0s21s20s2 ou 1s20s20s2
 */

s2 --> [];[0],s2,[0],s2,[1],s2;[0],s2,[1],s2,[0],s2;[1],s2,[0],s2,[0],s2.

/* exercice 1, Langage L3 : mots différents de leur renversé (c'est-à-dire non palindromes).
   Un mot de L3 est de la forme
   Sigma^p 0 Sigma* 1 Sigma^p, ou
   Sigma^p 1 Sigma* 0 Sigma^p.    
*/
s3 --> [0], t, [1];    [1], t, [0] ; x, s3, x.


sp3 --> [0] ; [1] ; [1], sp3, [0]; [0], sp3, [1].


/**
 *  L4 = { c#c' ; c, c' ∈ {0, 1}∗ et |c| différent de |c'|, # nouveau symbole }
 */

s4 --> sp4, x, t;x,t,sp4.
sp4 --> n4 ; x, sp4,x.
n4 --> [#].

s24 --> x,t,sp24;sp24,x,t.
sp24--> [#];x,sp24,x.

/*
%perso mais faux? appel sur ss5
s5 --> [];[0];[1].
sp5 --> s5,[1];s5,[0];[0],s5;[1],s5.
ss5 --> sp5,[#],s5;s5,[#],sp5.
*/

/*1 etoile*/
e1 --> [];[1],e1.

/*0 etoile*/
e0 --> [];[0],e0.

/* Les mots de L5 sont 
	les mots de L4 Union (Sigma^p 0 Sigma^* # Sigma^p 1 Sigma^*)  Union (Sigma^p 1 Sigma^* # Sigma^p 0 Sigma^*)
*/
			/*
			s5 --> s4 ; s50 ; s51.
			s50 --> s50g, [1], t.
			s51 --> s51g, [0], t.
			s50g --> n50 ; x, s50g, x.
			s51g --> n51 ; x, s51g, x.
			n50 --> [0], t, [#].
			n51 --> [1], t, [#].*/



s5 --> s4 ; t,[1],sd,[0], t ;t,[1], sd, [0], t.
sd --> [#] ; x, sd, x.

/*prof*/
s5b --> s4 ; s50 ; s51.
s50 --> s50g, [1], t.
s51 --> s51g, [0], t.
s50g --> [0], t, [#] ; x, s50g, x.
s51g --> [1], t, [#] ; x, s51g, x.

/* Langage L6 :
   un mot de L6 est de la forme
   L601 : (Sigma^p 0 Sigma^q) (Sigma^p 1 Sigma^q)  
   ou 
   L610 : (Sigma^p 1 Sigma^q) (Sigma^p 0 Sigma^q)  
    
   que l'on peut réécrire : 
   L601 : (Sigma^p 0 Sigma^p) (Sigma^q 1 Sigma^q)  
   ou 
   L610: (Sigma^p 1 Sigma^p) (Sigma^q 0 Sigma^q)  */

s6  --> s60, s61 ; s61, s60. 

s60 --> [0] ; x, s60, x.
s61 --> [1];  x, s61, x.


/* Langage L7 :
   un mot de L7 est de la forme 0 0* 0^p 1* 0^p 
*/
s7 --> [0], zeroStar, s71.
s71 --> unStar ; [0], s71, [0].

zeroStar --> [] ; [0], zeroStar.
unStar --> [] ; [1], unStar.

/* Langage L8 :
   un mot de L8 est de la forme 
   0^p 1^q 0^(p+q)
   que l'on peut réécrire
   0^p 1^q 0^(q+p)
   c'est-à-dire
   0^p (1^q 0^q) 0^p
*/
s8 --> n8; [0], s8, [0].
n8 --> []; [1], n8, [0].

/* Langage L9 :
   un mot de L9 est de la forme 
   0^p 0*(0 + 1)1* (1^q 0^q) 0^p
*/
s9 --> zeroStar, zeroOuUn, unStar, n8; [0], s9, [0].


zeroOuUn --> [0]; [1].

/* Langage L10 : 0p 1q 0r ; p + r > q 
   un mot de L10 est de la forme 
   L010 :  0 0* (0^p 1^p) (1^q 0^q) 0*
   ou
   L100 : 0* (0^p 1^p) (1^q 0^q) 0 0*
*/
s10 --> [0], zeroStar, zeroPunP, unQzeroQ, zeroStar ; zeroStar, zeroPunP, unQzeroQ, [0], zeroStar.

zeroPunP --> []; [0], zeroPunP, [1].
unQzeroQ --> []; [1], unQzeroQ, [0].

/** 
 *  Tester:
 *  ?consult(f2).
 *  ? chaine(C,[0,1,#]), not(not(s1(C,[]))).
 *  C = [0],
 *  C=[001];
 *  prédicat chaine
 */

chaine([],_).

chaine([X|X1],Sigma):-chaine(X1,Sigma),
member(X,Sigma).

/** 
 * Sigma étoile
 */

t --> []; x,t.
x --> [0]; [1].

/*
 * Partie controle 2010
 *
 */

/*C1 0* 1* 0* */

s11 --> zeroStar,unStar,zeroStar.
/*C2 {0^p 1^q 0^r avec p+q>0 et r>=0}*/
s12 --> zeroStar,([1];[0]),unStar,zeroStar.

/*C3 {0^P 1^Q 0^R , P+R>= 0, Q> 0}*/

s13 --> zeroStar,[1],unStar,zeroStar.

/*C4=C2 la seule chaine qui n'est pas acceptee est la chaine vide. r != 0 <=> p != 0*/

/*C5 = 0^P 1^Q 0^R avec P > R
  0*.0^p.1^q.0^r
*/
 
s15 --> [0],zeroStar,sp15. 
sp15 --> unStar;[0],sp15,[0].
/*
?- consult('/Users/RN/Documents/ENSEIGNEMENT/IF4-LLC/IF4-LLC-2011-2012/feuille-2/l6-l10.pl').
% /Users/RN/Documents/ENSEIGNEMENT/IF4-LLC/IF4-LLC-2011-2012/feuille-2/l6-l10.pl compiled 0.00 sec, 0 bytes
true.

?- chaine(C,[0,1]), not(not(s6(C,[]))).
C = [1, 0] ;
C = [0, 1] ;
C = [1, 0, 0, 0] ;
C = [0, 1, 0, 0] ;
C = [1, 1, 0, 0] ;
C = [0, 0, 1, 0] ;
C = [0, 1, 1, 0] ;
C = [1, 1, 1, 0] ;
C = [0, 0, 0, 1] ;
C = [1, 0, 0, 1] ;
C = [1, 1, 0, 1] ;
C = [0, 0, 1, 1] ;
C = [1, 0, 1, 1] ;
C = [0, 1, 1, 1] ;
C = [1, 0, 0, 0, 0, 0] .

?- chaine(C,[0,1]), not(not(s7(C,[]))).
C = [0] ;
C = [0, 0] ;
C = [0, 1] ;
C = [0, 0, 0] ;
C = [0, 0, 1] ;
C = [0, 1, 1] ;
C = [0, 0, 0, 0] ;
C = [0, 0, 1, 0] ;
C = [0, 0, 0, 1] ;
C = [0, 0, 1, 1] ;
C = [0, 1, 1, 1] ;
C = [0, 0, 0, 0, 0] ;
C = [0, 0, 0, 1, 0] .

?- chaine(C,[0,1]), not(not(s8(C,[]))).
C = [] ;
C = [0, 0] ;
C = [1, 0] ;
C = [0, 0, 0, 0] ;
C = [0, 1, 0, 0] ;
C = [1, 1, 0, 0] ;
C = [0, 0, 0, 0, 0, 0] .

?- chaine(C,[0,1]), not(not(s9(C,[]))).
C = [0] ;
C = [1] ;
C = [0, 0] ;
C = [0, 1] ;
C = [1, 1] ;
C = [0, 0, 0] ;
C = [0, 1, 0] ;
C = [1, 1, 0] ;
C = [0, 0, 1] ;
C = [0, 1, 1] ;
C = [1, 1, 1] ;
C = [0, 0, 0, 0] .

?- chaine(C,[0,1]), not(not(s10(C,[]))).
C = [0] ;
C = [0, 0] ;
C = [0, 0, 0] ;
C = [1, 0, 0] ;
C = [0, 1, 0] ;
C = [0, 0, 1] ;
C = [0, 0, 0, 0] ;
C = [1, 0, 0, 0] ;
C = [0, 1, 0, 0] ;
C = [0, 0, 1, 0] ;
C = [0, 0, 0, 1] ;
C = [0, 0, 0, 0, 0].

%*/

