﻿/* IF4-LLC, 3 janvier 2012, René Natowicz - feuille 2 */

/* Langage L6 :
   un mot de L6 est de la forme
   L601 : (Sigma^p 0 Sigma^q) (Sigma^p 1 Sigma^q)  
   ou 
   L610 : (Sigma^p 1 Sigma^q) (Sigma^p 0 Sigma^q)  
    
   que l'on peut réécrire : 
   L601 : (Sigma^p 0 Sigma^p) (Sigma^q 1 Sigma^q)  
   ou 
   L610: (Sigma^p 1 Sigma^p) (Sigma^q 0 Sigma^q)  */
s6  --> s601 ; s610. 

s601 --> s60, s61.
s610 --> s61, s60.

s60 --> [0] ; x, s60, x.
s61 --> [1];  x, s61, x.

x--> [0] ; [1].

/* Langage L7 :
   un mot de L7 est de la forme 0 0* 0^p 1* 0^p 
*/
s7 --> [0], zeroStar, s71.
s71 --> unStar ; [0], s71, [0].

zeroStar --> [] ; [0], zeroStar.
unStar --> [] ; [1], unStar.

/* Langage L8 :
   un mot de L8 est de la forme 
   0^p 1^q 0^(p+q)
   que l'on peut réécrire
   0^p 1^q 0^(q+p)
   c'est-à-dire
   0^p (1^q 0^q) 0^p
*/
s8 --> n8; [0], s8, [0].
n8 --> []; [1], n8, [0].

/* Langage L9 :
   un mot de L9 est de la forme 
   0^p 0*(0 + 1)1* (1^q 0^q) 0^p
*/
s9 --> zeroStar, zeroOuUn, unStar, n8; [0], s9, [0].
.

zeroOuUn --> [0]; [1].

/* Langage L10 : 0p 1q 0r ; p + r > q 
   un mot de L10 est de la forme 
   L010 :  0 0* (0^p 1^p) (1^q 0^q) 0*
   ou
   L100 : 0* (0^p 1^p) (1^q 0^q) 0 0*
*/
s10 --> [0], zeroStar, zeroPunP, unQzeroQ, zeroStar ; zeroStar, zeroPunP, unQzeroQ, [0], zeroStar.

zeroPunP --> []; [0], zeroPunP, [1].
unQzeroQ --> []; [1], unQzeroQ, [0].


chaine([],_Sigma).
chaine([X|C],Sigma) :- chaine(C,Sigma), member(X,Sigma).
















/*
?- consult('/Users/RN/Documents/ENSEIGNEMENT/IF4-LLC/IF4-LLC-2011-2012/feuille-2/l6-l10.pl').
% /Users/RN/Documents/ENSEIGNEMENT/IF4-LLC/IF4-LLC-2011-2012/feuille-2/l6-l10.pl compiled 0.00 sec, 0 bytes
true.

?- chaine(C,[0,1]), not(not(s6(C,[]))).
C = [1, 0] ;
C = [0, 1] ;
C = [1, 0, 0, 0] ;
C = [0, 1, 0, 0] ;
C = [1, 1, 0, 0] ;
C = [0, 0, 1, 0] ;
C = [0, 1, 1, 0] ;
C = [1, 1, 1, 0] ;
C = [0, 0, 0, 1] ;
C = [1, 0, 0, 1] ;
C = [1, 1, 0, 1] ;
C = [0, 0, 1, 1] ;
C = [1, 0, 1, 1] ;
C = [0, 1, 1, 1] ;
C = [1, 0, 0, 0, 0, 0] .

?- chaine(C,[0,1]), not(not(s7(C,[]))).
C = [0] ;
C = [0, 0] ;
C = [0, 1] ;
C = [0, 0, 0] ;
C = [0, 0, 1] ;
C = [0, 1, 1] ;
C = [0, 0, 0, 0] ;
C = [0, 0, 1, 0] ;
C = [0, 0, 0, 1] ;
C = [0, 0, 1, 1] ;
C = [0, 1, 1, 1] ;
C = [0, 0, 0, 0, 0] ;
C = [0, 0, 0, 1, 0] .

?- chaine(C,[0,1]), not(not(s8(C,[]))).
C = [] ;
C = [0, 0] ;
C = [1, 0] ;
C = [0, 0, 0, 0] ;
C = [0, 1, 0, 0] ;
C = [1, 1, 0, 0] ;
C = [0, 0, 0, 0, 0, 0] .

?- chaine(C,[0,1]), not(not(s9(C,[]))).
C = [0] ;
C = [1] ;
C = [0, 0] ;
C = [0, 1] ;
C = [1, 1] ;
C = [0, 0, 0] ;
C = [0, 1, 0] ;
C = [1, 1, 0] ;
C = [0, 0, 1] ;
C = [0, 1, 1] ;
C = [1, 1, 1] ;
C = [0, 0, 0, 0] .

?- chaine(C,[0,1]), not(not(s10(C,[]))).
C = [0] ;
C = [0, 0] ;
C = [0, 0, 0] ;
C = [1, 0, 0] ;
C = [0, 1, 0] ;
C = [0, 0, 1] ;
C = [0, 0, 0, 0] ;
C = [1, 0, 0, 0] ;
C = [0, 1, 0, 0] ;
C = [0, 0, 1, 0] ;
C = [0, 0, 0, 1] ;
C = [0, 0, 0, 0, 0].

*/